function [MEAN,MED,MAXC,Ts,th_d,th_h,th_tot] = Gibbs_LSAPC_x0(X,y,x0,it,l_0,alpha0,like,positive,mx)

gama = 1e-10;
gama_psi = 1e-2;
[N,n] = size(X);
mez = 0.2*it;
err1 = [];

mX = max(abs(X(:)));
my = max(abs(y));

a = my / 2;
b = mX / 5;

y = y./a;
X = X./b;
mx = mx * (b/a);
x0 = x0 .* (b/a);

alpha_sample = zeros(it,n);
theta_sample = zeros(it,n);
sigma_sample = zeros(it,1);
el_sample    = zeros(it,n-1);
psi_sample   = zeros(it,n-1);
Sum_theta    = zeros(it,1);

theta = ones(n,1);
alpha = ones(n,1)*alpha0;
el = ones(n-1,1)*l_0;
sigma = max(max(X'*X))^(-1);
% sigma = 1/std(y);

delta = ones(n-1,1);
beta = delta;
psi = delta;

% XX = X'*X;
Xy = X'*y';

try
    gamrnd(1,1);
    gamma_flag = 1;
catch
    gamma_flag = 0;
end

theta_days = zeros(it,10);
theta_3h = zeros(it,80);
theta_total = zeros(it,1);
opts = optimoptions('quadprog','display','off');
acc_ind = 0;

for i = 1:it
%% theta
    X2 = Xy*sigma;
    
    k = -1;
    pom = 1;
    while k < 0
        try
            L = diag(el,-1) + eye(n);            
            [R,~] = (rq([X'*sqrt(sigma), L*diag(sqrt(alpha))]));
            R = R(1:n,1:n);
            [U,T,V] = svd(R);
            iR = -V*diag(1./diag(T))*U';
            S = (iR'*iR);
            mu = S * (X2 + (L*diag(alpha)*L')*x0);
            if positive
                [theta_new,iff] = sample_tnN(mu,R*R',iR,opts,2e3,mx);
                if ~iff 
                    theta = theta_new;
                    acc_ind = 0;
                end
                acc_ind = acc_ind + 1;
                if acc_ind >= 20
                    print('Sample not accepted too many times. Trying new initialization')
                    [MEAN,MED,MAXC,Ts,th_d,th_h,th_tot] = Gibbs_LSAPC(X,y,it,l_0,alpha0,like,positive,mx);
                    return
                end
            else
                theta = mu + (randn(1,n)*iR)';
            end
            Sum_theta(i) = sum(theta);
            
            k = 1;
        catch
            alpha_j = gamma_rand(0.5 + gama, 1./(0.5*C + gama), gamma_flag);
            alpha_n = gamma_rand(0.5 + gama, 1./(0.5*(theta(n)-x0(n))^2 + gama), gamma_flag);
            alpha = [alpha_j; alpha_n];
            alpha_sample(i-1,:) = alpha;
            
            el = (dej_el(delta,beta,n))';
            el_sample(i-1,:) = el;
            
            sigma = gamma_rand(N/2 + gama, Delt, gamma_flag);
            sigma_sample(i-1,:) = sigma;

            pom = pom + 1;
            if pom == 10
                err1 = [err1 i];
                display('rnd')
                k = 1;
                
                theta = theta_sample(i-10,:)';
                alpha = alpha_sample(i-10,:)';
                el = el_sample(i-10,:)';
                psi = psi_sample(i-10,:)';
            end
        end
    end
%% sigma
    try
        Yth = (y'-X*theta);
    catch
        Yth = (y'-X*theta');
    end
    
    A = Yth'*Yth;
    Delt = 1/(gama + A/2);
    sigma = gamma_rand(N/2 + gama, Delt, gamma_flag);
    
%% alpha
    theta = theta - x0;
    C = (theta(1:(end-1)) + el.* theta(2:end)).^2;
    alpha_j = gamma_rand(0.5 + gama, 1./(0.5*C + gama), gamma_flag);
    alpha_n = gamma_rand(0.5 + gama, 1./(0.5*theta(n)^2 + gama), gamma_flag);
    alpha = [alpha_j; alpha_n];
%% el
    delta = psi*l_0 - theta(1:end-1).*theta(2:end).*alpha_j;
    beta = 1./(alpha_j.*(theta(2:end).^2) + psi);
    el = dej_el(delta,beta,n);
    el = el';
%% psi
    omeg = 1./(gama_psi + 0.5*(el - l_0).^2);
    psi = gamma_rand(gama_psi + 0.5, omeg, gamma_flag);
%% z�pis
    alpha_sample(i,:) = alpha;
    theta_sample(i,:) = theta + x0;
    sigma_sample(i,1) = sigma;
    el_sample(i,:)    = el;
    psi_sample(i,:)   = psi;

    if mod(i,5e3) == 0
        clc
        disp(['Current iteration: ',num2str(i)])
    end
    
end

alpha_sample = alpha_sample(mez:end,:) ./ (a/b)^2;
theta_sample = theta_sample(mez:end,:) .* (a/b);
theta_days   = theta_days(mez:end,:)   .* (a/b);
theta_3h     = theta_3h(mez:end,:)     .* (a/b);
theta_total  = theta_total(mez:end)    .* (a/b);
sigma_sample = sigma_sample(mez:end,:) ./ a^2;
el_sample    = el_sample(mez:end,:);
psi_sample   = psi_sample(mez:end,:);
Sum_theta    = Sum_theta(mez:end) .* (a/b);

exc = err1 < mez; err1(exc) = [];
exc = err1 - mez + 1;

if ~isempty(exc)
    alpha_sample(exc,:) = [];
    theta_sample(exc,:) = [];
    theta_days(exc,:)   = [];
    theta_3h(exc,:)     = [];
    theta_total(exc,:)  = [];
    sigma_sample(exc,:) = [];
    el_sample(exc,:)    = [];
    psi_sample(exc,:)   = [];
    Sum_theta(exc)      = [];
end

Ts = theta_sample; clear theta_sample
As = alpha_sample; clear alpha_sample
Ls = el_sample;    clear el_sample
Ps = psi_sample;   clear psi_sample
Ss = sigma_sample; clear sigma_sample
St = Sum_theta;    clear Sum_theta
th_d = theta_days; clear theta_day
th_h = theta_3h;   clear theta_3h
th_tot = theta_total; clear theta_total

% MEAN.th  = (mean(Ts))';
% MEAN.al  = (1./mean(As))';
% MEAN.sg  = 1/mean(Ss);
% MEAN.el  = (mean(Ls))';
% MEAN.psi = (1./mean(Ps))';
% MEAN.sum = mean(St);
% 
% MED.th  = (median(Ts))';
% MED.al  = (1./median(As))';
% MED.sg  = 1/median(Ss);
% MED.el  = (median(Ls))';
% MED.psi = (1./median(Ps))';
% MED.sum = median(St);
% 
% MAXC = dej_max(Ts,As,Ss,Ls,Ps,St,n);
MEAN = [];
MED = [];
MAXC = [];

if like
    MEAN.P = prav(Ts,MEAN.th,1./MEAN.al,1/MEAN.sg,MEAN.el,1./MEAN.psi,X,n,N,y,l_0,XX,Xy);
    MED.P  = prav(Ts,MED.th ,1./MED.al ,1/MED.sg ,MED.el ,1./MED.psi ,X,n,N,y,l_0,XX,Xy);
    MAXC.P = prav(Ts,MAXC.th,1./MAXC.al,1/MAXC.sg,MAXC.el,1./MAXC.psi,X,n,N,y,l_0,XX,Xy);
end

end

%%
function [P] = prav(Ts,th,al,sg,el,psi,X,n,N,y,l_0,XX,Xy)
it = 5e4;
a = 1e-10;
c = 1e-2;

%% odhad p(al*|sg*,l*,psi*,Y)
L = diag(el,-1) + eye(n);
Palpha(it) = 0;
gam = 0.5 + a;
lg = log(gamma(gam));
alpha = al;
S1 = X'*sqrt(sg);
S2 = Xy*sg;
for k = 1:it    
    [R,~] = (rq([S1, L*diag(sqrt(alpha))]));
    R = R(1:n,1:n);
    [U,T,V] = svd(R);
    iR = V*diag(1./diag(T))*U';
    S = (iR'*iR);
    mu = S*S2;    
    [theta,~] = dej_theta(mu,iR,n,1,[]);
    
    delt_j = a + 0.5*(theta(1:end-1) + el.*theta(2:end)).^2;
    delt = [delt_j; a + 0.5*theta(end)^2];
    
    alpha = gamrnd(gam,1./delt);
    
    Palpha(k) = sum(gam.*log(delt) - lg + (gam-1)*log(al) - al.*delt);
end
Palpha = Palpha(100:end);
MA = -max(Palpha) + 700;
Palpha = Palpha + MA;
Palpha = mean(exp(Palpha));

%% odhad p(l*|sg*,psi*,Y)
S1 = XX*sg;
S2 = Xy*sg;
gam = 0.5 + a;
Pel(it) = 0;
alpha = al;
elko = el;
for k = 1:it
    L = diag(elko,-1) + eye(n);

    [R,~] = (rq([S1, L*diag(sqrt(alpha))]));
    R = R(1:n,1:n);
    [U,T,V] = svd(R);
    iR = V*diag(1./diag(T))*U';
    S = (iR'*iR);
    mu = S*S2;    
    [theta,~] = dej_theta(mu,iR,n,1,[]);
    
    delt_j = a + 0.5*(theta(1:end-1) + elko.*theta(2:end)).^2;
    delt = 1./[delt_j; a + 0.5*theta(end)^2];
    alpha = gamrnd(gam,delt);
    
    ro = 1./(alpha(1:end-1) .* theta(2:end).^2 + psi); 
    PI = (psi*l_0 - theta(1:end-1).*theta(2:end) .* alpha(1:end-1));
    
    elko = (dej_el(PI,ro,n))';
    
    PI = PI.*ro;
    ro = 1./ro;
    Pel(k) = 0.5*sum(log(ro./(2*pi)) - ro.*(el - PI).^2);
end
Pel = Pel(1e2:end);
ML = -max(Pel) + 700;
Pel = Pel + ML;
Pel = mean(exp(Pel));

%% odhad p(psi*|sg*,Y)
S1 = XX*sg;
S2 = Xy*sg; 
elko = el;
alpha = al;
psicko = psi;
Ppsi(it) = 0;
lam = 0.5 + c;
lg = log(gamma(lam));
for k = 1:it
    L = diag(elko,-1) + eye(n);

    [R,~] = (rq([S1, L*diag(sqrt(alpha))]));
    R = R(1:n,1:n);
    [U,T,V] = svd(R);
    iR = V*diag(1./diag(T))*U';
    S = (iR'*iR);
    mu = S*S2;    
    [theta,~] = dej_theta(mu,iR,n,1,[]);  

    delt_j = a + 0.5*(theta(1:end-1) + elko.*theta(2:end)).^2;
    delt = 1./[delt_j; a + 0.5*theta(end)^2];
    alpha = gamrnd(gam,delt);
    
    ro = 1./(alpha(1:end-1) .* theta(2:end).^2 + psicko);
    PI = (psicko*l_0 - theta(1:end-1).*theta(2:end) .* alpha(1:end-1));
    elko = (dej_el(PI,ro,n))';
    
    omeg = c + 0.5*(elko - l_0).^2;
    psicko = gamrnd(lam,1./omeg);
    Ppsi(k) = sum(lam*log(omeg) - lg + (lam-1)*log(psi) - psi.*omeg);
end
Ppsi = Ppsi(1e2:end);
MP = -max(Ppsi) + 700;
Ppsi = Ppsi + MP;
Ppsi = mean(exp(Ppsi));

%% Rao-Blackwell na sigma
Gam = N/2 + a;
Pom = sum(log(1:(N/2-1)));
Delt = a + 0.5*(sum((repmat(y',1,size(Ts,1)) - X*Ts').^2,1))';
RBs = Gam*log(Delt) - Pom + (Gam-1)*log(sg) - sg*Delt;
MS = -max(RBs) + 200;
RBs = RBs + MS;
RBs = mean(exp(RBs));

%% pravd�podobnost
a = 1e-10;
c = 1e-2;
S1 = XX*sg;
L = diag(el,-1) + eye(n);
LL = L*diag(al)*L';
S = S1 + LL;
vS = 0.5*sum(log(eig(S)));
Ym = y' - X*th;
P = N/2 * log(sg/(2*pi)) - 0.5*sg*(Ym'*Ym) + (a-0.5)*sum(log(al))...
    - 0.5*(th'*LL*th) - (n+1) * log(gamma(a)) - a*sum(al) ...
    + (a-1)*log(sg) - a*sg + (n-1)*log(c^c / gamma(c))...
    + 0.5*sum(log(psi/(2*pi)) - psi.*(el-l_0).^2) + (c-1)*sum(log(psi))...
    - c*sum(psi) - vS - log(RBs) - log(Palpha) - log(Pel) - log(Ppsi)...
    + MA + ML + MP + MS;
end

%%
function [theta,err1] = dej_theta(mu,ch,n,i,err1,uper_bound)

t = true;
poc = 0;
mam = false(n,1);

lower_bound = 0;
iter = 100;

th2(1:n,1) = - 1 + lower_bound;
th = repmat(mu,1,iter) + (randn(iter,n)*ch)';

while t
    poc = poc + 1;
    th(mam,poc) = - 1 + lower_bound;
    pom1 = th(:,poc) > lower_bound;
    pom2 = th(:,poc) < uper_bound;
    l = pom1 & pom2;
    th2(l,1) = th(l,poc);
    mam(l) = 1;
    if sum(mam) == length(mu)
        t = false;
    elseif poc >= iter
        t = false;
        c = find(~mam == 1);
        err1 = [err1 i];
        for k = 1:length(c)
            if th(c(k),poc) > uper_bound
                th2(c(k),1) = uper_bound;
            else
                th2(c(k),1) = lower_bound;
            end
        end
    end
end
theta = th2;
end

%%
function [el] = dej_el(delta,beta,n)
t = true;
n = n - 1;
pom = logical(1:n);
el_p(n) = 0;
poc = 0;

up = 1;
down = -2;

delta_beta = delta .* beta;
sq_beta = sqrt(beta);

while t
    if sum(pom) == 0
        break
    end
    if poc == 200
        el_p(el_p > up) = up;
        el_p(el_p < down) = down;
        break
    end
    poc = poc + 1;
    % el_p(pom) = mvnrnd(delta(pom).*beta(pom),diag(beta(pom)));
    el_p(pom) = delta_beta(pom) + randn([sum(pom),1]).*sq_beta(pom);
    pom = or(el_p > up, el_p < down); 
end

el = el_p;
end

%%
function [x] = gamma_rand(alpha, beta, gamma_flag)
    
if gamma_flag
    x = gamrnd(alpha, beta);
else
    n = length(alpha + beta);
    if length(alpha) ~= n
        alpha = ones(n,1) * alpha;
    end
    if length(beta) ~= n
        alpha = ones(n,1) * beta;
    end
    beta = 1./ beta;
    x(n) = 0;
    for k = 1:n
        if alpha(k) > 1
            d = alpha(k) - 1/3;
            c = 1/(sqrt(9*d));
            flag = 1;
            while flag
                Z = randn;
                if Z > -1/c
                    V = (1 + c*Z)^3;
                    U = rand;
                    flag = log(U) > (0.5*Z^2 + d - d*V + d*log(V));
                end
            end
            x(k) = d*V / beta(k);
        else
            x(k) = gamma_rand(alpha(k) + 1, beta(k), gamma_flag);
            x(k) = x(k) * rand^(1/alpha(k));
        end
    end
    x = x';
end

end

%%
function [MAXC] = dej_max(Ts,As,Ss,Ls,Ps,St,n)
%% theta
TT(n) = 0;
for k = 1:n    
    V = Ts(:,k);
    [f,xi] = ksdensity(V,linspace(min(V),max(V),6e3));
    [~,bb] = max(f);
    TT(k) = xi(bb);
end
MAXC.th = TT';

%% alpha
AA(n) = 0;
for k = 1:n
    V = As(:,k);    
    [f,xi] = ksdensity(V,linspace(min(V),max(V),6e3));
    [~,bb] = max(f);
    AA(k) = xi(bb);
end
MAXC.al = 1./AA';

%% sigma
V = Ss;
[f,xi] = ksdensity(V,linspace(min(V),max(V),6e3));
[~,bb] = max(f);
MAXC.sg = xi(bb);

%% el
LL(n-1) = 0;
for k = 1:(n-1)  
    V = Ls(:,k);
    [f,xi] = ksdensity(V,linspace(min(V),max(V),6e3));
    [~,bb] = max(f);
    LL(k) = xi(bb);
end
MAXC.el = LL';

%% psi
PP(n-1) = 0;
for k = 1:(n-1)
    V = Ps(:,k);
    [f,xi] = ksdensity(V,linspace(min(V),max(V),6e3));
    [~,bb] = max(f);
    PP(k) = xi(bb);
end
MAXC.psi = PP';

%% sum theta
[f,xi] = ksdensity(St,linspace(min(St),max(St),6e3));
[~,bb] = max(f);
MAXC.sum = xi(bb);

end